/*
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) 2014 - Scilab Enterprises - Antoine ELIAS
 *
 * Copyright (C) 2012 - 2016 - Scilab Enterprises
 *
 * This file is hereby licensed under the terms of the GNU GPL v2.0,
 * pursuant to article 5.3.4 of the CeCILL v.2.1.
 * This file was originally licensed under the terms of the CeCILL v2.1,
 * and continues to be available under such terms.
 * For more information, see the COPYING file which you should have received
 * along with this program.
 *
 */

/*------------------------------------------------------------------------*/
/* file: get_info_message_property.c                                       */
/* desc : function to retrieve in Scilab the info_message field of a       */
/*        handle                                                          */
/*------------------------------------------------------------------------*/

#include "getHandleProperty.h"
#include "returnProperty.h"
#include "Scierror.h"
#include "localization.h"

#include "getGraphicObjectProperty.h"
#include "graphicObjectProperties.h"

/*------------------------------------------------------------------------*/
void* get_groupname_property(void* _pvCtx, int iObjUID)
{
    char *pstGroupName = NULL;
    getGraphicObjectProperty(iObjUID, __GO_UI_GROUP_NAME__, jni_string, (void **)&pstGroupName);

    if (pstGroupName == NULL)
    {
        Scierror(999, _("'%s' property does not exist for this handle.\n"), "groupname");
        return NULL;
    }

    return sciReturnString(pstGroupName);
}
/*------------------------------------------------------------------------*/
